// ReverbDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dsp.h"
#include "ReverbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReverbDlg dialog


CReverbDlg::CReverbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReverbDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CReverbDlg)
	m_ApplyTo = -1;
	m_EarlyAmp = 0;
	m_InputAmp = 0;
	m_PreDelay = 0.0;
	m_EarlyDel1 = 0.0;
	m_EarlyDel2 = 0.0;
	m_EarlyDel3 = 0.0;
	m_ReverbAmp = 0;
	m_ReverbTime = 1.0;
	m_TailDelay1 = 0.0;
	m_TailDelay2 = 0.0;
	m_TailDelay3 = 0.0;
	m_TailDelay4 = 0.0;
	m_EarlyAmp1 = 0.0;
	m_EarlyAmp2 = 0.0;
	m_EarlyAmp3 = 0.0;
	//}}AFX_DATA_INIT
}


void CReverbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReverbDlg)
	DDX_CBIndex(pDX, IDC_APPLYTO, m_ApplyTo);
	DDX_Slider(pDX, IDC_EARLYAMP, m_EarlyAmp);
	DDX_Slider(pDX, IDC_INPUTAMP, m_InputAmp);
	DDX_Text(pDX, IDC_PREDELAY, m_PreDelay);
	DDV_MinMaxDouble(pDX, m_PreDelay, 0., 200.);
	DDX_Text(pDX, IDC_RDEL1, m_EarlyDel1);
	DDV_MinMaxDouble(pDX, m_EarlyDel1, 0., 200.);
	DDX_Text(pDX, IDC_RDEL2, m_EarlyDel2);
	DDV_MinMaxDouble(pDX, m_EarlyDel2, 0., 200.);
	DDX_Text(pDX, IDC_RDEL3, m_EarlyDel3);
	DDV_MinMaxDouble(pDX, m_EarlyDel3, 0., 200.);
	DDX_Slider(pDX, IDC_REVERBAMP, m_ReverbAmp);
	DDX_Text(pDX, IDC_REVERBTIME, m_ReverbTime);
	DDV_MinMaxDouble(pDX, m_ReverbTime, 0.5, 5.);
	DDX_Text(pDX, IDC_RTAIL1, m_TailDelay1);
	DDV_MinMaxDouble(pDX, m_TailDelay1, 0., 200.);
	DDX_Text(pDX, IDC_RTAIL2, m_TailDelay2);
	DDV_MinMaxDouble(pDX, m_TailDelay2, 0., 200.);
	DDX_Text(pDX, IDC_RTAIL3, m_TailDelay3);
	DDV_MinMaxDouble(pDX, m_TailDelay3, 0., 200.);
	DDX_Text(pDX, IDC_RTAIL4, m_TailDelay4);
	DDV_MinMaxDouble(pDX, m_TailDelay4, 0., 200.);
	DDX_Text(pDX, IDC_EARLYAMP1, m_EarlyAmp1);
	DDV_MinMaxDouble(pDX, m_EarlyAmp1, -1., 1.);
	DDX_Text(pDX, IDC_EARLYAMP2, m_EarlyAmp2);
	DDV_MinMaxDouble(pDX, m_EarlyAmp2, -1., 1.);
	DDX_Text(pDX, IDC_EARLYAMP3, m_EarlyAmp3);
	DDV_MinMaxDouble(pDX, m_EarlyAmp3, -1., 1.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CReverbDlg, CDialog)
	//{{AFX_MSG_MAP(CReverbDlg)
	ON_WM_VSCROLL()
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReverbDlg message handlers

BOOL CReverbDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	if (!m_ApplyTo)
	{
		CComboBox *cb = (CComboBox *)GetDlgItem(IDC_APPLYTO);
		cb->DeleteString(1);
	}
	CSliderCtrl *sl = (CSliderCtrl *)GetDlgItem(IDC_INPUTAMP);
	sl->SetRangeMin(0);
	sl->SetRangeMax(40);
	sl->SetTicFreq(3);
	sl = (CSliderCtrl *)GetDlgItem(IDC_EARLYAMP);
	sl->SetRangeMin(0);
	sl->SetRangeMax(40);
	sl->SetTicFreq(3);
	sl = (CSliderCtrl *)GetDlgItem(IDC_REVERBAMP);
	sl->SetRangeMin(0);
	sl->SetRangeMax(40);
	sl->SetTicFreq(3);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CReverbDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	int id = -1, pos;
	double p;

	CSliderCtrl *sl = (CSliderCtrl *)pScrollBar;
	char s[20];

	switch (sl->GetDlgCtrlID())
	{
		case IDC_INPUTAMP: id = IDC_VAL1; break;
		case IDC_EARLYAMP: id = IDC_VAL2; break;
		case IDC_REVERBAMP: id = IDC_VAL3; break;
	}

	if (id > 0)
	{
		pos = -sl->GetPos();
		if (pos > -40)
		{
			p = pow(10, (double)pos / 10) * 100;
			sprintf(s, "%d \n(%.2f%c)", pos, p, '%');
		}
		else
			strcpy(s, "-Inf \n(0%)");
		SetDlgItemText(id, s);
	}

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CReverbDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_INPUTAMP));
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_EARLYAMP));
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_REVERBAMP));
}

void CReverbDlg::OnSave() 
{
	// TODO: Add your control notification handler code here
	CFileDialog s(false, "fil", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"   (*.rev)|*.rev|  (*.*)|*.*||",
		this);

	if (s.DoModal() != IDOK) return;
	if (!UpdateData()) return;

	CFile f(s.GetPathName(), CFile::modeCreate | CFile::modeWrite);
	CArchive ar(&f, CArchive::store);

	ar << CString("REVERB");
	ar.Write(&m_InputAmp, sizeof(int));
	ar.Write(&m_EarlyAmp, sizeof(int));
	ar.Write(&m_ReverbAmp, sizeof(int));
	ar.Write(&m_EarlyDel1, sizeof(double));
	ar.Write(&m_EarlyAmp1, sizeof(double));
	ar.Write(&m_EarlyDel2, sizeof(double));
	ar.Write(&m_EarlyAmp2, sizeof(double));
	ar.Write(&m_EarlyDel3, sizeof(double));
	ar.Write(&m_EarlyAmp3, sizeof(double));
	ar.Write(&m_TailDelay1, sizeof(double));
	ar.Write(&m_TailDelay2, sizeof(double));
	ar.Write(&m_TailDelay3, sizeof(double));
	ar.Write(&m_TailDelay4, sizeof(double));
	ar.Write(&m_PreDelay, sizeof(double));
	ar.Write(&m_ReverbTime, sizeof(double));

	ar.Close();
	f.Close();
}

void CReverbDlg::OnLoad() 
{
	// TODO: Add your control notification handler code here
	CFileDialog o(true, "fil", NULL, OFN_HIDEREADONLY,
		"   (*.rev)|*.rev|  (*.*)|*.*||",
		this);

	if (o.DoModal() != IDOK) return;
	
	CFile f(o.GetPathName(), CFile::modeRead);
	CArchive ar(&f, CArchive::load);
	CString sig;

	ar >> sig;
	if (sig != "REVERB")
		AfxThrowArchiveException(CArchiveException::badIndex, o.GetPathName());

	ar.Read(&m_InputAmp, sizeof(int));
	ar.Read(&m_EarlyAmp, sizeof(int));
	ar.Read(&m_ReverbAmp, sizeof(int));
	ar.Read(&m_EarlyDel1, sizeof(double));
	ar.Read(&m_EarlyAmp1, sizeof(double));
	ar.Read(&m_EarlyDel2, sizeof(double));
	ar.Read(&m_EarlyAmp2, sizeof(double));
	ar.Read(&m_EarlyDel3, sizeof(double));
	ar.Read(&m_EarlyAmp3, sizeof(double));
	ar.Read(&m_TailDelay1, sizeof(double));
	ar.Read(&m_TailDelay2, sizeof(double));
	ar.Read(&m_TailDelay3, sizeof(double));
	ar.Read(&m_TailDelay4, sizeof(double));
	ar.Read(&m_PreDelay, sizeof(double));
	ar.Read(&m_ReverbTime, sizeof(double));

	UpdateData(false);
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_INPUTAMP));
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_EARLYAMP));
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_REVERBAMP));

	ar.Close();
	f.Close();
}
